/*******************************************************************************
 * Copyright (c) 2007  NTT DATA CORPORATION
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Version: 1.0.0 - 2007/06/15
 *          initial API and implementation
 *******************************************************************************/
package jp.sourceforge.tomoyo.core.local.model.except;

import jp.sourceforge.tomoyo.core.local.model.AbstractExceptPolicyElement;

public abstract class ConditionalElement extends AbstractExceptPolicyElement {

	public ConditionalElement(String name, int line, int column) {
		super(name, line, column);
		parse();
	}

	protected abstract void parse();
	
	protected String target;
	
	protected String condition;
	
	public String getCondition() {
		return condition;
	}
	
	public boolean isConditionDomain() {
		if (hasCondition())
			return condition.startsWith("<kernel>");
		return false;
	}

	public String getTarget() {
		return target;
	}

	public boolean hasCondition() {
		return (condition != null);
	}
	
}
